package rocks.zipcode;

import java.util.Collections;
import java.util.List;
import java.util.Scanner;

public class Blackjack {

    public enum PlayerInput {
        STAY("stay"), HIT("hit");

        private String input;
        PlayerInput(String s) {
            this.input = s;
        }
        public PlayerInput getInput() {
            return this;
        }
    }


    public static void main(String[] args) {

    Blackjack blackjack = new Blackjack();

    List<Cards> deck = Cards.newDeck();
    Collections.shuffle(deck);

    blackjack.runGame(deck);


    }

    // runGame()
    public void runGame(List<Cards> deck) {
        BlackJackRule rule = new BlackJackRule();

        System.out.println("Welcome to Zipcode Casino!");
        //create player
        Player player = new Player("You");
        Player dealer = new Player("Dealer");

        //deal card
        dealCard(player, deck);
        dealCard(dealer, deck);
        dealCard(player, deck);
        dealCard(dealer, deck);

        play(deck, player, rule);
        play(deck, dealer, rule);


        System.out.println(player.getName() + " hand score is " + player.handScore());
        player.printHand();

        System.out.println(dealer.getName() + " hand score is " + dealer.handScore());
        dealer.printHand();

        //get winner
        Player winner = rule.getWinner(dealer, player);
        if (winner == null) {
            System.out.println("Draw!");
        } else {
            System.out.println(winner.getName() + " wins!");
        }
    }

    private void dealCard(Player player, List<Cards> deck) {
        player.addCard(deck.remove(0));
    }

    private void play(List<Cards> deck, Player player, BlackJackRule rule) {
        boolean hitAgain = true;
        while(hitAgain) {
            System.out.println(player.getName() + "'s score is " + player.handScore());
            player.printHand();

            if (rule.isBusted(player)) {
                System.out.println(player.getName() + " is busted!");
                hitAgain = false;
            } else {
                //ask player what they want to do
                PlayerInput playerInput = getPLayerInput();
                if (playerInput == PlayerInput.HIT) {
                    dealCard(player, deck);
                } else {
                    hitAgain = false;
                }
            }
        }
    }

    public PlayerInput getPLayerInput() {
        // prompt the user to enter either "hit" or "stay"
        System.out.println("Hit or Stay?");

        Scanner scanner = new Scanner(System.in);
        String userInput = scanner.nextLine().trim();
        return PlayerInput.valueOf(userInput.toUpperCase());

        // read the player's input, if not either "hit" or "stay"

    }

    public void printCurrentGame() {

    }


    //        Define your methods:
//        hit() or deal_card()
    public Cards hit(Cards deck) {
        return null;
    }

    //        dealerDraw(dealerScore)
    public boolean dealerDraw(Player dealer) {
        return false;
    }

    //        checkWin(dealerScore,playerScore)
    public Player checkWinner(Player dealer, Player player1) {
        return null;
    }

    //        isBust(score)
    public boolean isBust(Player p){
        return false;
    }
}
