package rocks.zipcode;

import java.util.ArrayList;
import java.util.List;
//import java.util.Random;

public class Cards {

    public static final String NAME = "name1";

    public static final String HEARTS = "\u2665";
    public static final String SPADES = "\u2660";
    public static final String DIAMONDS = "\u2666";
    public static final String CLUBS = "\u2663";


    public enum Rank {
        DEUCE(2), THREE(3), FOUR(4), FIVE(5), SIX(6), SEVEN(7), EIGHT(8), NINE(
                9), TEN(10), JACK(10), QUEEN(10), KING(10), ACE(11);

        private int Rankpoints;

        Rank(int points) {
            this.Rankpoints = points;
        }

        public int getRankpoints() {
            return this.Rankpoints;
        }

    }

    public enum Suit {
        CLUBS('\u2660'), DIAMONDS('\u2666'), HEARTS('\u2665'), SPADES('\u2663');

        private char Suitpoints;

        Suit(char points) {

            this.Suitpoints = points;

        }

        public char getSuitpoints() {
            return this.Suitpoints;
        }

    }

    private final Rank rank;
    private final Suit suit;

    protected Cards(Rank rank, Suit suit) {
        this.rank = rank;
        this.suit = suit;
    }

    public Rank rank() {
        return this.rank;
    }

    public Suit suit() {

        return this.suit;

    }

    public String toString() {
        return rank + " of " + suit.getSuitpoints() + " " + suit;
    }

    private static final List<Cards> protoDeck = new ArrayList<Cards>();

    // Initialize prototype deck
    static {
        for (Suit suit : Suit.values())
            for (Rank rank : Rank.values())
                protoDeck.add(new Cards(rank, suit));

    }

    public static ArrayList<Cards> newDeck() {

        return new ArrayList<Cards>(protoDeck); // Return copy of prototype deck
    }

}

