package rocks.zipcode;

import java.util.ArrayList;
import java.util.List;

public class Player {
    private String name;

    private List<Cards> currentHand = new ArrayList<Cards>();

    Player() {

    }

    public Player(String name) {
        this.name = name;
    }

    public void addCard(Cards c) {
        currentHand.add(c);
    }

    public int handScore() {
        int score = 0;
        for (Cards c : currentHand) {
            score = score + c.rank().getRankpoints();
        }
        return score;
    }

    public void clearHand() {
        currentHand.clear();
    }

    public void printHand() {
        System.out.print("[");
        for (Cards c : currentHand) {
            System.out.print(c.toString()+", ");
        }
        System.out.println("]");
    }

    public String toString(){
        return name;
    }

    public String getName() {
        return name;
    }
}
